/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.camera.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import javax.persistence.*;
import javax.validation.constraints.*;
import javax.persistence.Entity;
import javax.persistence.Table;

import me.zhengjie.base.BaseEntity;
import org.hibernate.annotations.*;
import java.sql.Timestamp;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-04-20
**/
@Entity
@Data
@Table(name="dm_camera")
public class DmCamera extends BaseEntity implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "主键")
    private Long id;

    @Column(name = "code")
    @ApiModelProperty(value = "摄像头编号")
    private String code;

    @Column(name = "name")
    @ApiModelProperty(value = "摄像头名称")
    private String name;

    @Column(name = "camera_param")
    @ApiModelProperty(value = "摄像头参数(摄像头基本参数)")
    private String cameraParam;

    @Column(name = "address")
    @ApiModelProperty(value = "摄像头位置(摄像头安装位置)")
    private String address;

    @Column(name = "restaurant")
    @ApiModelProperty(value = "所属餐厅(摄像头所属餐厅)")
    private String restaurant;

    public void copy(DmCamera source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }
}