/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.food.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import me.zhengjie.base.BaseEntity;
import me.zhengjie.utils.SecurityUtils;
import org.springframework.security.core.userdetails.UserDetails;

import javax.persistence.*;
import javax.validation.constraints.*;
import java.sql.Timestamp;
import java.math.BigDecimal;
import java.io.Serializable;
import java.util.Date;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-15
**/
@Entity
@Data
@Table(name="dm_food")
public class DmFood extends BaseEntity implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "id")
    private Long id;

    @Column(name = "code",nullable = false)
    @ApiModelProperty(value = "编号")
    private String code;

    @Column(name = "name",nullable = false)
    @ApiModelProperty(value = "名称")
    private String name;

    @Column(name = "price",nullable = false)
    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    @Column(name = "picture")
    @ApiModelProperty(value = "图片")
    private String picture;

    @Column(name = "remark")
    @ApiModelProperty(value = "描述")
    private String remark;

    @Column(name = "type")
    @ApiModelProperty(value = "类型")
    private String type;

    @Column(name = "pstate")
    @ApiModelProperty(value = "菜品状态")
    private Integer pstate;

    public void copy(DmFood source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }

//    @PrePersist
//    public void prePersist() {
//        UserDetails user = SecurityUtils.getCurrentUser();
//        this.createBy = user.getUsername();
//        this.createTime = new Timestamp(new Date().getTime());
//    }

//    @PreUpdate
//    public void preUPdate() {
//        UserDetails user = SecurityUtils.getCurrentUser();
//        this.updateBy = user.getUsername();
//        this.updateTime = new Timestamp(new Date().getTime());
//    }
}