/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.foodPj.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import me.zhengjie.modules.dm.user.domain.DmUser;

import javax.persistence.*;
import javax.validation.constraints.*;
import java.sql.Timestamp;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-15
**/
@Entity
@Data
@Table(name="dm_food_pj")
public class DmFoodPj implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "id")
    private Long id;

    @Column(name = "oid")
    @ApiModelProperty(value = "orderItem")
    private Long oid;

    @Column(name = "food_name")
    @ApiModelProperty(value = "菜品名称")
    private String foodName;

    @Column(name = "food_code")
    @ApiModelProperty(value = "菜品编号")
    private String foodCode;

    @Column(name = "food_type")
    @ApiModelProperty(value = "菜品分类")
    private String foodType;

    @OneToOne
    @JoinColumn(name = "user_code",referencedColumnName = "id")
    @ApiModelProperty(value = "用户工号")
    private DmUser userCode;

    @Column(name = "user_name")
    @ApiModelProperty(value = "用户姓名")
    private String userName;

    @Column(name = "order_time")
    @ApiModelProperty(value = "下单时间")
    private Timestamp orderTime;

    @Column(name = "order_bh")
    @ApiModelProperty(value = "订单编号")
    private String orderBh;

    @Column(name = "pj_time")
    @ApiModelProperty(value = "评价时间")
    private Timestamp pjTime;

    @Column(name = "pj_star")
    @ApiModelProperty(value = "评价星级")
    private String pjStar;

    @Column(name = "pj_tag")
    @ApiModelProperty(value = "评价标签")
    private String pjTag;

    @Column(name = "pj_desc")
    @ApiModelProperty(value = "评价详情")
    private String pjDesc;

    @Column(name = "pj_pic")
    @ApiModelProperty(value = "上传图片")
    private String pjPic;

    public void copy(DmFoodPj source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }
}