/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.order.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import java.util.List;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.modules.dm.order.domain.DmOrderItem;
import me.zhengjie.modules.system.domain.Dept;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-15
**/
@Data
public class DmOrderRecordDto implements Serializable {

    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

//    private String bh;
    //订单编号
//    private List<DmOrderItem> orderItem;
//    private DmOrderItemSmallDto orderItem;
    private List<DmOrderItem> orderItems;

    private String bh;

    //实付金额
    private String money;

    //用户唯一识别号
    private String mob;

    private String tel;

    private Integer cardProfile;
    //用户工号
    private String userCode;

    //用户姓名
    private String userName;

    //用户部门
    private Dept dept;

    //人员种类
    private String userType;

    //用户手机号
    private String phone;

    //下单时间
    private Timestamp createDate;

    //合计金额
    private String totalMoney;

    //折扣
    private String zkMoney;

    //流水号
    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long seq;

    //卡id
    private String card;

    //卡no
    private String cardNo;

    //餐别 1-早餐,2-午餐,3-晚餐,4-夜宵
    private Integer part;

    //终端id
    private Integer term;

    //餐厅id
    private Integer shop;

    //终端名称
    private String termName;

   //餐厅名称
    private String shopName;

    //金额
    private Double amt;

    //卡余额
    private Double balance;

    //账户类型 0-主账户、1-补贴账户
    private Integer account;

    //支付类型 11-主账户、21-补贴账户、 2-现金、 3-银联、30-扫码支付、31-微信、32-支付宝
    private Integer type;
}