/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.settlement.domain;

import lombok.Data;
import cn.hutool.core.bean.BeanUtil;
import io.swagger.annotations.ApiModelProperty;
import cn.hutool.core.bean.copier.CopyOptions;
import javax.persistence.*;
import javax.validation.constraints.*;
import javax.persistence.Entity;
import javax.persistence.Table;

import me.zhengjie.base.BaseEntity;
import org.hibernate.annotations.*;
import java.sql.Timestamp;
import java.math.BigDecimal;
import java.io.Serializable;

/**
* @website https://el-admin.vip
* @description /
* @author xwx
* @date 2021-04-22
**/
@Entity
@Data
@Table(name="dm_settlement")
public class DmSettlement extends BaseEntity implements Serializable {

    @Id
    @Column(name = "id")
    @ApiModelProperty(value = "主键")
    private Long id;

    @Column(name = "food_name")
    @ApiModelProperty(value = "菜品名称")
    private String foodName;

    @Column(name = "food_price")
    @ApiModelProperty(value = "菜品单价")
    private BigDecimal foodPrice;

    @Column(name = "food_num")
    @ApiModelProperty(value = "点餐数量")
    private Integer foodNum;

    @Column(name = "total_price")
    @ApiModelProperty(value = "小计(点餐价格合计)")
    private BigDecimal totalPrice;

    @Column(name = "order_time")
    @ApiModelProperty(value = "点餐时间")
    private Timestamp orderTime;

    @Column(name = "card_code")
    @ApiModelProperty(value = "结算卡号")
    private String cardCode;

    public void copy(DmSettlement source){
        BeanUtil.copyProperties(source,this, CopyOptions.create().setIgnoreNullValue(true));
    }
}