package me.zhengjie.modules.quartz.task;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alipay.api.FileItem;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import me.zhengjie.exception.BadRequestException;
import me.zhengjie.modules.dm.video.domain.DmVideo;
import me.zhengjie.modules.dm.video.service.DmVideoService;
import me.zhengjie.utils.BeanMapUtils;
import me.zhengjie.utils.FileUtil;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.commons.CommonsMultipartFile;
import sun.misc.BASE64Decoder;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Slf4j
@RequiredArgsConstructor
@Component
public class VideoDataTask {
    private final DmVideoService dmVideoService;

    public void run(){
        log.info("deptsync 执行开始");
        videoSync();
        log.info("deptsync 执行结束");
    }

    private void videoSync(){
        String url = "http://xxx:xxx/xxx";

//        JSONObject dataJSON = JSONObject.parseObject(BeanMapUtils.doPostForm(url,null));
        String postData = BeanMapUtils.doPostForm(url,null);
        MultipartFile dataJSON = JSONObject.parseObject(postData,MultipartFile.class);
        JSONObject jsonObject = JSONObject.parseObject(postData);
        JSONArray content = jsonObject.getJSONArray("data");
        // 判断文件是否为图片
        String suffix = FileUtil.getExtensionName(dataJSON.getOriginalFilename());
        if(!FileUtil.VIDEO.equals(FileUtil.getFileType(suffix))){
            throw new BadRequestException("只能上传图片");
        }

        for (int i = 0; i < content.size(); i++) {
            MultipartFile file = JSONObject.parseObject(content.getString(i), MultipartFile.class);
            dmVideoService.create(null,file);
        }

        //按页获取
//        for (int k = 0; k < pageTotal; k++) {
//            JSONObject newGenerateProcDataJson = getData(url,data);
//            JSONObject dataJSON = newGenerateProcDataJson.getJSONObject("data");
//            JSONArray data1 = dataJSON.getJSONArray("data");
//            for (int i = 0; i < data1.size(); i++) {
//                DmPlateTraffic dmPlateTraffic = JSONObject.parseObject(data1.getString(i), DmPlateTraffic.class);
//                dmPlateTrafficRepository.save(dmPlateTraffic);
//            }
//        }
    }

}
